#ifndef _MQSEC_H_
#define _MQSEC_H_
#include "cmqc.h"
#include "rsaeuro.h"                /* include rsaeuro function header file */
#define TRUE 1
#define FALSE 0
typedef signed short SHORT;
typedef unsigned char UBYTE;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
#ifndef _WIN32
typedef unsigned char BOOL;
#endif
#ifdef MLDEBUG
# define D(x) x                        /* expand only when debugging */
# define ND(x)                        /* expand only when not debugging */
#else
# define D(x)
# define ND(x) x
#endif
#define MQRE_HAM_MSGLEN 0x0901
#define MQRE_HAM_MSG 0x0902
typedef struct
{
  unsigned int errorno;
  char *errmsg;
}
MQRE_MSG;
typedef struct
{
  unsigned char iv[8];
  unsigned char encryptedKey[MAX_ENCRYPTED_KEY_LEN];
  unsigned int encryptedKeyLen;
  unsigned char signature[MAX_SIGNATURE_LEN];
  unsigned int signatureLen;
}
MQ_DIGITAL_SIGNATURE;
typedef struct
{
  unsigned char hambuf[256];
  unsigned int hambuflen;
  unsigned char hamEncryptedBuf[32];
  unsigned int hamEncryptedBufLen;
  MQ_DIGITAL_SIGNATURE mqdigsig;
}
MQ_HAM;
typedef struct
{
  unsigned char qmgr[MQ_Q_MGR_NAME_LENGTH + 1];
  unsigned int qmgrLen;
  R_RSA_PUBLIC_KEY pubk;
  R_RSA_PRIVATE_KEY privk;
}
MQ_QMGR_DATA;
typedef struct
{
  unsigned char channel[MQ_CHANNEL_NAME_LENGTH + 1];
  unsigned char qmgrA[MQ_Q_MGR_NAME_LENGTH + 1];
  unsigned char qmgrB[MQ_Q_MGR_NAME_LENGTH + 1];
  MQ_DIGITAL_SIGNATURE mqdigsig;
}
MQ_CHANNEL_DATA;
/* Define eyecatchers */
#define QMGR_NAME_EYE_CATCHER "<QUEUEMANAGER NAME>"
#define QMGR_NAME_EYE_CATCHER_SIZE sizeof(QMGR_NAME_EYE_CATCHER)
#define CSSD_PUBK_EYE_CATCHER "<CSSD PUBLIC KEY>"
#define CSSD_PUBK_EYE_CATCHER_SIZE sizeof(CSSD_PUBK_EYE_CATCHER)
#define QMGR_PUBK_EYE_CATCHER "<QMGR PUBLIC KEY>"
#define QMGR_PUBK_EYE_CATCHER_SIZE sizeof(QMGR_PUBK_EYE_CATCHER)
#define QMGR_PRIVK_EYE_CATCHER "<QMGR PRIVATE KEY>"
#define QMGR_PRIVK_EYE_CATCHER_SIZE sizeof(QMGR_PRIVK_EYE_CATCHER)
#define CHANNEL_NAME_EYE_CATCHER "<CHANNEL NAME>"
#define CHANNEL_NAME_EYE_CATCHER_SIZE sizeof(CHANNEL_NAME_EYE_CATCHER)
#define DIGSIG_EYE_CATCHER "<DIGITAL SIGNATURE>"
#define DIGSIG_EYE_CATCHER_SIZE sizeof(DIGSIG_EYE_CATCHER)
#define HAM_EYE_CATCHER "<HAM>"
#define HAM_EYE_CATCHER_SIZE sizeof(HAM_EYE_CATCHER)
#define MSG_EYE_CATCHER "<MESSAGE>"
#define MSG_EYE_CATCHER_SIZE sizeof(MSG_EYE_CATCHER)
#define MQ_DO_COMPRESS 1
#define MQ_DO_NO_COMPRESS 0
#define MQ_FLAG_Copied (UBYTE ) 0x80
#define MQ_FLAG_Compress (UBYTE) 0x40
#endif
